#!/bin/bash
# run as enstore/package_enstore_bin.sh from directory above enstore
NAME=enstore_distr
if [[ ! -v VERSION ]]; then
    VERSION=0.1
fi
if [[ ! -v REL ]]; then
    REL=3
fi
VERS=${NAME}-${VERSION}

if [ ! -d enstore ]; then
   echo "`basename $0` is expecting to be executed as enstore/packaging/`basename $0`" >&2
   exit 1
fi

# Create rpm build environment
echo "%_topdir ${HOME}/rpm" > ~/.rpmmacros
echo "%_tmppath /tmp" >> ~/.rpmmacros
#rm -rf ~/rpm
mkdir -p ~/rpm/BUILD ~/rpm/RPMS ~/rpm/SOURCES ~/rpm/SPECS ~/rpm/SRPMS
sed -e "s/__VERSION__/${VERSION}/g" -e "s/__RELEASE__/${REL}/g" ./enstore/spec/enstore_distr.spec >  ~/rpm/SPECS/enstore_distr.spec

# Package product for rpmbuild
export ENSTORE_INSTALL_DIR=$HOME/enstore_distr_dir/${VERS}
if [ ! -d $ENSTORE_INSTALL_DIR ]; then
    mkdir -p $ENSTORE_INSTALL_DIR
fi

pushd .
cd enstore/ftt/ftt_lib
make clean; make;make install
popd
cp -r . $ENSTORE_INSTALL_DIR/
sed -e "s/\/enstore/\/enstore_bin_distr/" enstore/etc/enstore.service >  \
 $ENSTORE_INSTALL_DIR/etc/enstore.service
sed -e "s/\/enstore/\/enstore_bin_distr/" enstore/etc/enstore-monitor.service >  \
 $ENSTORE_INSTALL_DIR/etc/enstore-monitor.service


cd $ENSTORE_INSTALL_DIR
cd ..
echo "PWD `pwd`"
echo "MAKING ${VERS}.tgz from"
tar -czf ${VERS}.tgz ${VERS}/enstore/*
#tar czvf ${VERS}.tgz . --exclude VERS}.tgz --exclude-vcs
cp ${VERS}.tgz ~/rpm/SOURCES/
echo "PWD `pwd`"
#cp spec/enstore_distr.spec ~/rpm/SPECS
echo "Calling rpmbuild"
# Create rpmbuild
rpmbuild -bb ~/rpm/SPECS/enstore_distr.spec || exit 1

