Summary: Enstore: Mass Storage System Whole Distribution
Name: enstore_dev
Version: __VERSION__
Release: __RELEASE__%{?dist}
License: GPL
Group: Applications/System
Source0: %{name}-%{version}.tgz
#Source: %{name}.tgz
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-XXXXXX)
AutoReqProv: no
AutoProv: no
AutoReq: no
Prefix: opt/%{name}
%global _missing_build_ids_terminate_build 0
%undefine __brp_mangle_shebangs
%define _build_id_links none
%define debug_package %{nil}
%global __arch_install_post %{nil}
# disable python_byte_compile
%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')

%description
Enstore Distributed Mass Storage System.
The main storage media it uses is magnetic tape, although the new media can be added.
Beginning with version 3.X File Aggregation Feature is added.
This is development ditribution version
For the postinstallation and configuration instructions please see README

%prep
echo "DOING SETUP"
%setup -q
echo "RPM SETUP DONE"

%build
echo "RPM BUILD"

%install
echo "RPM INSTALL"
mkdir -p $RPM_BUILD_ROOT/%{prefix}
cp -rp ./ $RPM_BUILD_ROOT/%{prefix}
if [ ! -d $RPM_BUILD_ROOT/usr/local/etc ]; then
	mkdir -p $RPM_BUILD_ROOT/usr/local/etc
fi
if [ ! -f $RPM_BUILD_ROOT/usr/local/etc/setups.sh ];then
	cp -r $RPM_BUILD_ROOT/%{prefix}/external_distr/setups.sh $RPM_BUILD_ROOT/usr/local/etc/setups.sh
fi

echo INSTALL DONE
%pre
PATH=/usr/sbin:$PATH
# check if user "enstore" and group "enstore "exist"

echo 'Checking if group "enstore" exists'
getent group enstore >/dev/null || groupadd -g 6209 enstore
echo 'Checking if user "enstore" exists'
getent passwd enstore >/dev/null || useradd -u 5744 -g enstore enstore;chmod 775 ~enstore
ENSTORE_HOME=`getent passwd enstore | cut -d: -f6`
mkdir -p $ENSTORE_HOME/site_specific/config

# save existing enstore distribution
d=`date "+%%F-%T"`
if [ -d $RPM_BUILD_ROOT/%{prefix} ]; then
   echo "copying $RPM_BUILD_ROOT/%{prefix} to /tmp/enstore_backup.$d"
   cp -rp $RPM_BUILD_ROOT/%{prefix} /tmp/enstore_backup.$d
else
    echo "$RPM_BUILD_ROOT/%{prefix} is there"
fi

%post
echo "POSTINSTALL"
export ENSTORE_DIR=$RPM_BUILD_ROOT/%{prefix}

echo "Check $ENSTORE_DIR/site_specific/config/setup-enstore and modify it as necessary"
$ENSTORE_DIR/external_distr/update_sym_links.sh
rm -f $ENSTORE_DIR/debugfiles.list
rm -f $ENSTORE_DIR/debugsources.list
echo "Enstore installed. Please read README file"

%preun
echo "PRE UNINSTALL"
#$RPM_BUILD_ROOT/%{prefix}/external_distr/rpm_uninstall.sh $1
%clean
rm -rf $RPM_BUILD_ROOT/*

%files
%defattr(-,enstore,enstore,-)
%doc
/%{prefix}
%config /usr/local/etc/setups.sh
%config(noreplace) /%{prefix}/dcache-deploy/scripts/setup-enstore

%changelog
